#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>


struct protoent *getprotobynumber(int proto)
{
    static char h[DBUFSIZE];
    struct protoent *ptr;
    REGS_t in,out;
    int res;
    int ch;

    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = IP_GETPROTOBYNUMBER;
        in.D1 = proto;
        in.D3 = -1;
        in.A0 = (addreg_t)ch;
        in.A2 = (addreg_t)h;    
        res = neterrno(in.A0, qdos3(&in, &out));
        ptr = (res < 0) ? NULL : h;
        io_close(ch);
    }
    else
    {
        errno = EINVAL;
        ptr = NULL;
    }
    return ptr;
}


