#define __LIBRARY__
#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>
#include <fcntl.h>

int recv (int s, void *b, int ln, unsigned int flag)
{
    REGS_t in,out;
    int res;

    CHECK_SOCKET(s);
    
    in.D0 = IP_RECV;
    in.D1 = flag;
    in.D2 = ln;
    in.D3 = _GetTimeout(_Chkufb(s));
    in.A0 = (addreg_t)getchid(s);
    in.A1 = b;
    res = qdos3(&in, &out);
    if(res < 0)
    {
	switch (res)
        {
            case ERR_NC: errno==EAGAIN; 
                break;
                    /* probably other errors should be handled here */
            default: neterrno(in.A0, res);
        }
        res = -1;
    }
    else
    {
        res = out.D1;
    }
    return res;
}
