#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>

char *inet_ntoa(struct in_addr ina)
{
    REGS_t in,out;
    int res;
    int ch;
    unsigned long u = (unsigned long )-1;
    static char buf[128];
    
    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = IP_INET_NTOA;
        in.D3 = -1;
        in.A0 = (addreg_t)ch;
        in.A1 = (addreg_t)&ina;
        in.A2 = (addreg_t)&buf;            
        res = neterrno(in.A0, qdos3(&in, &out));
        io_close(ch);
    }
    else
    {
        errno = EINVAL;
    }
    return (res) ? NULL : buf;
}
